#!/bin/sh

# set the current directory to be equal to the one this file resides in.
# this is important if we want to work when our icon is clicked
cd `echo $0 | sed 's/Click_To_Install_SpicyKeys.sh//'`

echo "Installing SpicyKeys..."
echo "--------------------------------------------------------------"
echo "Adding the SpicyKeys preferences applet to /boot/preferences.."
copyattr -d bin/SpicyKeys.$BE_HOST_CPU /boot/preferences/SpicyKeys

echo "Adding link to preferences menu..."
ln -s /boot/preferences/SpicyKeys ~/config/be/Preferences/SpicyKeys

# remove old version from inappropriate directory
rm -f /system/add-ons/input_server/filters/SpicyKeyCatcher*
rm -f ~/config/add-ons/input_server/filters/SpicyKeyCatcher*

echo "Adding the SpicyKeyCatcher add-on to ~/config/add-ons/input_server/filters..."
cp bin/SpicyKeyCatcher.$BE_HOST_CPU ~/config/add-ons/input_server/filters

echo "Adding the dospicy utility to your ~/config/bin folder..."
cp bin/dospicy.$BE_HOST_CPU ~/config/bin/dospicy

if test -e ~/config/settings/spicykeys_settings; then
   echo "[SpicyKey settings already exist, so I won't overwrite them]"
else
   echo "Adding the default SpicyKey settings file to ~/config/settings..."
   cp bin/spicykeys_settings.sample ~/config/settings/spicykeys_settings
fi

echo "Restarting the input_server..."
/boot/beos/system/servers/input_server -q
echo ""
echo "All done!  Use the SpicyKeys prefs panel to configure your SpicyKeys."
echo "---------------------------------------------------------------------"

alert --idea "SpicyKeys is installed!  Open the SpicyKeys prefs panel via the Preferences menu (or by pressing left-window-k) to configure your SpicyKeys!" &
