#include "JResizableButton.h"

JResizableButton :: JResizableButton(BRect parentFrame, BRect frame, const char * name, const char * label, BMessage * msg)
   : BButton(frame, name, label, msg, B_FOLLOW_BOTTOM, B_WILL_DRAW | B_NAVIGABLE)
{
   float width = parentFrame.right - parentFrame.left;
   float height = parentFrame.bottom - parentFrame.top;   
   _percentages.left   = frame.left  / width;
   _percentages.top    = frame.top   / height;
   _percentages.right  = frame.right / width;
   _percentages.bottom = frame.bottom / height;      
}
 
void JResizableButton :: ChangeToNewSize(float newWidth, float newHeight)
{
    float newX = _percentages.left * newWidth;
    float newW = (_percentages.right * newWidth) - newX;
    BRect b = Frame();
    MoveBy(newX-b.left, 0);
    ResizeTo(newW, b.bottom-b.top); 
    Invalidate();
}
  
