#include <stdio.h>
#include <string.h>
#include "MetaKeyStateMap.h"
#include "BitFieldTesters.h"

MetaKeyStateMap :: MetaKeyStateMap()
   : _keyName(NULL)
{
   // User MUST call SetInfo() before using!
}

MetaKeyStateMap :: MetaKeyStateMap(const char * name)
{
   SetInfo(name);
}
 
void MetaKeyStateMap :: SetInfo(const char * keyName)
{
  _keyName = new char[strlen(keyName)+1];
   strcpy(_keyName, keyName);
}

MetaKeyStateMap :: ~MetaKeyStateMap()
{
   delete [] _keyName;
   for (int i=0; i<_stateDescs.CountItems(); i++) delete [] ((const char *) _stateDescs.ItemAt(i));
   for (int j=0; j<_stateTesters.CountItems(); j++) delete ((BitFieldTester *) _stateTesters.ItemAt(j));
   // _stateBits are stored in-line, no need to delete them
}

void MetaKeyStateMap :: AddState(const char * d, const BitFieldTester * t)
{
   char * copy = new char[strlen(d)+1];
   strcpy(copy, d);
   _stateDescs.AddItem(copy);
   
   _stateTesters.AddItem((void *)t);
}

int MetaKeyStateMap :: GetNumStates() const
{
   return _stateTesters.CountItems();
}

const BitFieldTester * MetaKeyStateMap :: GetNthStateTester(int stateNum) const
{
   return ((const BitFieldTester *) _stateTesters.ItemAt(stateNum));
}

const char * MetaKeyStateMap :: GetNthStateDesc(int stateNum) const
{
   return ((const char *) _stateDescs.ItemAt(stateNum));
}

const char * MetaKeyStateMap :: GetName() const
{
   return _keyName;
}
