#ifndef SpicyKeysServerFilter_h
#define SpicyKeysServerFilter_h

#include <stdio.h>

#include <app/Messenger.h>
#include <app/Message.h>
#include <support/List.h>
#include <add-ons/input_server/InputServerFilter.h>
#include <storage/File.h>

#ifdef __POWERPC__
#pragma export on
#endif

// export this for the input_server
extern "C" _EXPORT BInputServerFilter * instantiate_input_filter();

class KeyCommandMap;
class CommandExecutor;

class SpicyKeysServerFilter : public BInputServerFilter
{
public:
   SpicyKeysServerFilter();
   virtual ~SpicyKeysServerFilter();
   
   virtual status_t InitCheck();
   
   virtual filter_result Filter(BMessage * message, BList * outlist);
   
private:
//   BFile _debugOutput;
   
   KeyCommandMap * _map;         // Tells us what command goes with a given key
   CommandExecutor * _executor;  // Executes the given commands
   BMessenger _messenger;        // Points to _executor: declaration order is important!!!
};

#ifdef __POWERPC__
#pragma export reset
#endif

#endif
